<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.ruoyi.project.sems.mapper.TSpecdevDtMapper">

    <resultMap type="TSpecdevDt" id="TSpecdevDtResult">
        <result property="id"    column="id"    />
        <result property="plantCode"    column="plant_code"    />
        <result property="unit"    column="unit"    />
        <result property="devname"    column="devname"    />
        <result property="devno"    column="devno"    />
        <result property="createdate"    column="createdate"    />
        <result property="submitdate"    column="submitdate"    />
        <result property="status"    column="status"    />
        <result property="delFlag"    column="del_flag"    />
        <result property="createrCode"    column="creater_code"    />
        <result property="createrDate"    column="creater_date"    />
        <result property="updaterCode"    column="updater_code"    />
        <result property="updaterDate"    column="updater_date"    />
        <result property="deptId"    column="dept_id"    />
        <result property="remarks"    column="remarks"    />
        <result property="remarks2"    column="remarks2"    />
        <result property="approveStatus"    column="approve_status"    />
        <result property="regno"    column="regno"    />
        <result property="useno"    column="useno"    />
        <result property="warnDate"    column="warn_date"    />
        <result property="warnCycle"    column="warn_cycle"    />
        <result property="nextWarnDate"    column="next_warn_date"    />
        <result property="warnFlag"    column="warn_flag"    />
        <result property="model"    column="model"    />
        <result property="capacity"    column="capacity"    />
        <result property="floor"    column="floor"    />
        <result property="createUnit"    column="create_unit"    />
        <result property="maintContractor"    column="maint_contractor"    />
        <result property="location"    column="location"    />
        <result property="checkStrategy"    column="check_strategy"    />
        <result property="firstWarnDate"    column="first_warn_date"    />
        <result property="checkUnit"    column="check_unit"    />
        <result property="docno"    column="docno"    />
        <result property="approveTime"    column="approve_time"    />
        <result property="changeTime"    column="change_time"    />
        <result property="reportNo"    column="report_no"    />
        <result property="hiFlag" column="hiFlag" />
        <result property="perTestConclusion" column="per_test_conclusion" />
        <result property="isRepeat" column="is_repeat"/>
        <result property="useDept"    column="use_dept"    />
        <result property="plantMaint"    column="plant_maint"    />

    </resultMap>

    <sql id="selectTSpecdevDtVo">
        select d.id, d.plant_code,d.plant_maint,d.use_dept, d.unit, d.devname, d.devno, d.createdate, d.submitdate, d.status, d.del_flag, d.creater_code, d.creater_date, d.updater_code, d.updater_date, d.dept_id, d.remarks,d.remarks2,  d.approve_status, d.regno, d.useno, d.warn_date, d.warn_cycle, d.next_warn_date, d.warn_flag, d.model, d.capacity, d.floor, d.create_unit, d.maint_contractor, d.location, d.check_strategy, d.first_warn_date, d.check_unit, d.docno, d.approve_time, d.change_time, d.report_no ,s.dept_name,
        (SELECT COUNT(1) from T_SPECHI_DT h  where h.DEV_ID = d.id and HI_TYPE = 0 ) as hiFlag, per_test_conclusion
        ,d.is_repeat
        from t_specdev_dt d
      left join sys_dept s on s.dept_id = d.dept_id
    </sql>

    <select id="selectTSpecdevDtList" parameterType="TSpecdevDt" resultMap="TSpecdevDtResult">
        <include refid="selectTSpecdevDtVo"/>
        <where>
            <if test="plantCode != null  and plantCode != ''"> and plant_code devname like concat(concat('%', #{plantCode}), '%')</if>
            <if test="unit != null  and unit != ''"> and unit like concat(concat('%', #{unit}), '%')</if>
            <if test="devname != null  and devname != ''"> and devname like concat(concat('%', #{devname}), '%')</if>
            <if test="devno != null  and devno != ''"> and devno like concat(concat('%', #{devno}), '%')</if>
            <if test="status != null "> and d.status = #{status}</if>
            <if test="approveStatus != null ">and approve_status = #{approveStatus}</if>
            <if test="warnFlag != null ">and warn_Flag = #{warnFlag}</if>
            <if test="searchValue != null  and searchValue != ''">
                and
                (plant_code like concat(concat('%', #{searchValue}), '%')
                or unit like concat(concat('%', #{searchValue}), '%')
                or devname like concat(concat('%', #{searchValue}), '%')
                or devno like concat(concat('%', #{searchValue}), '%')
                or remarks like concat(concat('%', #{searchValue}), '%')
                or remarks2 like concat(concat('%', #{searchValue}), '%')
                or report_no like concat(concat('%', #{searchValue}), '%')

                )
            </if>
            <if test="isRepeat != null  and isRepeat != ''">
                <if test="isRepeat == 2 ">
                    and  (d.REGNO, d.PLANT_CODE, d.DEL_FLAG, d.APPROVE_STATUS) IN (
                    SELECT REGNO, PLANT_CODE, DEL_FLAG, APPROVE_STATUS
                    FROM T_SPECDEV_DT
                    WHERE DEL_FLAG = 0 AND APPROVE_STATUS = 0
                    GROUP BY REGNO, PLANT_CODE, DEL_FLAG, APPROVE_STATUS
                    HAVING COUNT(*) > 1
                    )
                </if>
            </if>
            and d.del_flag = 0
        </where>
        <!-- 数据范围过滤 -->
        ${params.dataScopePlant}
        order by d.is_repeat desc, d.plant_code, d.unit ,d.id
    </select>

    <select id="selectExpiredDt" parameterType="TSpecdevDt" resultMap="TSpecdevDtResult">
        select d.id, d.plant_code,d.plant_maint,d.use_dept, d.unit, d.devname, d.devno, d.createdate, d.submitdate, d.status, d.del_flag, d.creater_code, d.creater_date, d.updater_code, d.updater_date, d.dept_id, d.remarks, d.remarks2,d.approve_status, d.regno, d.useno, d.warn_date, d.warn_cycle, d.next_warn_date, d.warn_flag, d.model, d.capacity, d.floor, d.create_unit, d.maint_contractor, d.location, d.check_strategy, d.first_warn_date, d.check_unit, d.docno, d.approve_time, d.change_time, d.report_no
        from t_specdev_dt d
        where SYSDATE > NEXT_WARN_DATE
          and DEL_FLAG = 0
          and STATUS = 1
        order by d.plant_code asc
    </select>


    <select id="selectTSpecdevDtListByYear" parameterType="TSpecdevDt" resultMap="TSpecdevDtResult">
        <include refid="selectTSpecdevDtVo"/>
        <where>
            <if test="status != null ">and d.status = #{status}</if>
            <if test="checkYear != null ">and to_char(NEXT_WARN_DATE,'yyyyMM') = #{checkYear}</if>
            <if test="plantIds != null  and plantIds != ''">
                and
                d.plant_code in
                <foreach collection="plantIds.split(',')" item="item" index="index"
                         open="(" close=")" separator=",">
                    #{item}
                </foreach>
            </if>
            <!--<if test="unitIds != null  and unitIds != ''">
                and
                (
                d.unit in
                <foreach collection="unitIds.split(',')" item="item" index="index"
                         open="(" close=")" separator=",">
                    #{item}
                </foreach>
                or
                d.plant_code in
                <foreach collection="unitIds.split(',')" item="item" index="index"
                         open="(" close=")" separator=",">
                    #{item}
                </foreach>
                )
            </if>-->
            and d.del_flag = 0
        </where>

    </select>



    <select id="selectTSpecdevDtById" parameterType="Long" resultMap="TSpecdevDtResult">
        <include refid="selectTSpecdevDtVo"/>
        where id = #{id}
    </select>

    <insert id="insertTSpecdevDt" parameterType="TSpecdevDt">
        <selectKey keyProperty="id" resultType="long" order="BEFORE">
            SELECT seq_t_specdev_ylrq.NEXTVAL as id FROM DUAL
        </selectKey>
        insert into t_specdev_dt
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="id != null">id,</if>
            <if test="plantCode != null and plantCode != ''">plant_code,</if>
            <if test="unit != null">unit,</if>
            <if test="devname != null">devname,</if>
            <if test="devno != null">devno,</if>
            <if test="createdate != null">createdate,</if>
            <if test="submitdate != null">submitdate,</if>
            <if test="status != null">status,</if>
            <if test="delFlag != null">del_flag,</if>
            <if test="createrCode != null">creater_code,</if>
            <if test="createrDate != null">creater_date,</if>
            <if test="updaterCode != null">updater_code,</if>
            <if test="updaterDate != null">updater_date,</if>
            <if test="deptId != null">dept_id,</if>
            <if test="remarks != null">remarks,</if>
            <if test="remarks2 != null">remarks2,</if>
            <if test="approveStatus != null">approve_status,</if>
            <if test="regno != null">regno,</if>
            <if test="useno != null">useno,</if>
            <if test="warnDate != null">warn_date,</if>
            <if test="warnCycle != null">warn_cycle,</if>
            <if test="nextWarnDate != null">next_warn_date,</if>
            <if test="warnFlag != null">warn_flag,</if>
            <if test="model != null">model,</if>
            <if test="capacity != null">capacity,</if>
            <if test="floor != null">floor,</if>
            <if test="createUnit != null">create_unit,</if>
            <if test="maintContractor != null">maint_contractor,</if>
            <if test="location != null">location,</if>
            <if test="checkStrategy != null">check_strategy,</if>
            <if test="firstWarnDate != null">first_warn_date,</if>
            <if test="checkUnit != null">check_unit,</if>
            <if test="docno != null">docno,</if>
            <if test="approveTime != null">approve_time,</if>
            <if test="changeTime != null">change_time,</if>
            <if test="reportNo != null">report_no,</if>
            <if test="perTestConclusion != null">per_test_conclusion,</if>
            <if test="plantMaint != null">plant_maint,</if>
            <if test="useDept != null">use_dept,</if>
        </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="id != null">#{id},</if>
            <if test="plantCode != null and plantCode != ''">#{plantCode},</if>
            <if test="unit != null">#{unit},</if>
            <if test="devname != null">#{devname},</if>
            <if test="devno != null">#{devno},</if>
            <if test="createdate != null">#{createdate},</if>
            <if test="submitdate != null">#{submitdate},</if>
            <if test="status != null">#{status},</if>
            <if test="delFlag != null">#{delFlag},</if>
            <if test="createrCode != null">#{createrCode},</if>
            <if test="createrDate != null">#{createrDate},</if>
            <if test="updaterCode != null">#{updaterCode},</if>
            <if test="updaterDate != null">#{updaterDate},</if>
            <if test="deptId != null">#{deptId},</if>
            <if test="remarks != null">#{remarks},</if>
            <if test="remarks2 != null">#{remarks2},</if>
            <if test="approveStatus != null">#{approveStatus},</if>
            <if test="regno != null">#{regno},</if>
            <if test="useno != null">#{useno},</if>
            <if test="warnDate != null">#{warnDate},</if>
            <if test="warnCycle != null">#{warnCycle},</if>
            <if test="nextWarnDate != null">#{nextWarnDate},</if>
            <if test="warnFlag != null">#{warnFlag},</if>
            <if test="model != null">#{model},</if>
            <if test="capacity != null">#{capacity},</if>
            <if test="floor != null">#{floor},</if>
            <if test="createUnit != null">#{createUnit},</if>
            <if test="maintContractor != null">#{maintContractor},</if>
            <if test="location != null">#{location},</if>
            <if test="checkStrategy != null">#{checkStrategy},</if>
            <if test="firstWarnDate != null">#{firstWarnDate},</if>
            <if test="checkUnit != null">#{checkUnit},</if>
            <if test="docno != null">#{docno},</if>
            <if test="approveTime != null">#{approveTime},</if>
            <if test="changeTime != null">#{changeTime},</if>
            <if test="reportNo != null">#{reportNo},</if>
            <if test="perTestConclusion != null">#{perTestConclusion},</if>
            <if test="plantMaint != null">#{plantMaint},</if>
            <if test="useDept != null">#{useDept},</if>
         </trim>
    </insert>

    <update id="updateTSpecdevDt" parameterType="TSpecdevDt">
        update t_specdev_dt
        <trim prefix="SET" suffixOverrides=",">
            <if test="plantCode != null and plantCode != ''">plant_code = #{plantCode},</if>
            <if test="unit != null">unit = #{unit},</if>
            <if test="devname != null">devname = #{devname},</if>
            <if test="devno != null">devno = #{devno},</if>
            <if test="createdate != null">createdate = #{createdate},</if>
            <if test="submitdate != null">submitdate = #{submitdate},</if>
            <if test="status != null">status = #{status},</if>
            <if test="delFlag != null">del_flag = #{delFlag},</if>
            <if test="createrCode != null">creater_code = #{createrCode},</if>
            <if test="createrDate != null">creater_date = #{createrDate},</if>
            <if test="updaterCode != null">updater_code = #{updaterCode},</if>
            <if test="updaterDate != null">updater_date = #{updaterDate},</if>
            <if test="deptId != null">dept_id = #{deptId},</if>
            <if test="remarks != null">remarks = #{remarks},</if>
            <if test="remarks2 != null">remarks2 = #{remarks2},</if>
            <if test="approveStatus != null">approve_status = #{approveStatus},</if>
            <if test="regno != null">regno = #{regno},</if>
            <if test="useno != null">useno = #{useno},</if>
            <if test="warnDate != null">warn_date = #{warnDate},</if>
            <if test="warnCycle != null">warn_cycle = #{warnCycle},</if>
            <if test="nextWarnDate != null">next_warn_date = #{nextWarnDate},</if>
            <if test="warnFlag != null">warn_flag = #{warnFlag},</if>
            <if test="model != null">model = #{model},</if>
            <if test="capacity != null">capacity = #{capacity},</if>
            <if test="floor != null">floor = #{floor},</if>
            <if test="createUnit != null">create_unit = #{createUnit},</if>
            <if test="maintContractor != null">maint_contractor = #{maintContractor},</if>
            <if test="location != null">location = #{location},</if>
            <if test="checkStrategy != null">check_strategy = #{checkStrategy},</if>
            <if test="firstWarnDate != null">first_warn_date = #{firstWarnDate},</if>
            <if test="checkUnit != null">check_unit = #{checkUnit},</if>
            <if test="docno != null">docno = #{docno},</if>
            <if test="approveTime != null">approve_time = #{approveTime},</if>
            <if test="changeTime != null">change_time = #{changeTime},</if>
            <if test="reportNo != null">report_no = #{reportNo},</if>
            <if test="perTestConclusion != null">per_test_conclusion = #{perTestConclusion},</if>
            <if test="isRepeat != null">is_repeat = #{isRepeat},</if>
            <if test="plantMaint != null">plant_maint = #{plantMaint},</if>
            <if test="useDept != null">use_dept = #{useDept},</if>
        </trim>
        where id = #{id}
    </update>

    <update id="updateTSpecdevDtByHi" parameterType="TSpecdevDt">
        update t_specdev_dt
        <trim prefix="SET" suffixOverrides=",">
            <if test="plantCode != null and plantCode != ''">plant_code = #{plantCode},</if>
            <if test="unit != null">unit = #{unit},</if>
            <if test="devname != null">devname = #{devname},</if>
            <if test="devno != null">devno = #{devno},</if>
            <if test="createdate != null">createdate = #{createdate},</if>
            <if test="submitdate != null">submitdate = #{submitdate},</if>
            <if test="status != null">status = #{status},</if>
            <if test="delFlag != null">del_flag = #{delFlag},</if>
            <if test="createrCode != null">creater_code = #{createrCode},</if>
            <if test="createrDate != null">creater_date = #{createrDate},</if>
            <if test="updaterCode != null">updater_code = #{updaterCode},</if>
            <if test="updaterDate != null">updater_date = #{updaterDate},</if>
            <if test="deptId != null">dept_id = #{deptId},</if>
            <if test="remarks != null">remarks = #{remarks},</if>
            <if test="remarks2 != null">remarks2 = #{remarks2},</if>
            <if test="approveStatus != null">approve_status = #{approveStatus},</if>
            <if test="regno != null">regno = #{regno},</if>
            <if test="useno != null">useno = #{useno},</if>
            <if test="warnDate != null">warn_date = #{warnDate},</if>
            <if test="warnCycle != null">warn_cycle = #{warnCycle},</if>
            <if test="nextWarnDate != null">next_warn_date = #{nextWarnDate},</if>
            <if test="warnFlag != null">warn_flag = #{warnFlag},</if>
            <if test="model != null">model = #{model},</if>
            <if test="capacity != null">capacity = #{capacity},</if>
            <if test="floor != null">floor = #{floor},</if>
            <if test="createUnit != null">create_unit = #{createUnit},</if>
            <if test="maintContractor != null">maint_contractor = #{maintContractor},</if>
            <if test="location != null">location = #{location},</if>
            <if test="checkStrategy != null">check_strategy = #{checkStrategy},</if>
            <if test="firstWarnDate != null">first_warn_date = #{firstWarnDate},</if>
            <if test="checkUnit != null">check_unit = #{checkUnit},</if>
            <if test="docno != null">docno = #{docno},</if>
            <if test="approveTime != null">approve_time = #{approveTime},</if>
            <if test="changeTime != null">change_time = #{changeTime},</if>
            <if test="reportNo != null">report_no = #{reportNo},</if>
            <if test="perTestConclusion != null">per_test_conclusion = #{perTestConclusion},</if>
            <if test="plantMaint != null">plant_maint = #{plantMaint},</if>
            <if test="useDept != null">use_dept = #{useDept},</if>
        </trim>
        where id = #{devId}
    </update>


    <update id="deleteTSpecdevDtById" parameterType="Long">
        update t_specdev_dt set del_flag = 2 where id = #{id}
    </update>

    <update id="deleteTSpecdevDtByIds" parameterType="String">
        update t_specdev_dt set del_flag = 2 where id in
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </update>

    <select id="otherDevCount" resultType="com.ruoyi.project.sems.domain.DevData">
        SELECT COUNT(1) as num,to_char(t.NEXT_WARN_DATE,'yyyyMM') as yearM FROM "T_SPECDEV_DT" t
        where
        t.status = 1
        and del_flag = 0
        and t.PLANT_CODE in
        <foreach collection="plants" item="plant" index="index"
                 open="(" close=")" separator=",">
            #{plant}
        </foreach>
        GROUP BY to_char(t.NEXT_WARN_DATE,'yyyyMM')
    </select>

    <update id="duplicateTSpecdevDt" >
        UPDATE  T_SPECDEV_DT set DEL_FLAG = 2
        where rowid !=( select max(rowid)
        from T_SPECDEV_DT b
        where b.REGNO = T_SPECDEV_DT.REGNO and b.PLANT_CODE = T_SPECDEV_DT.PLANT_CODE and T_SPECDEV_DT.DEL_FLAG = 0 and b.DEL_FLAG = 0
        and T_SPECDEV_DT.APPROVE_STATUS = 0
        )
    </update>
</mapper>
